// bszip.h
//declare BigSpeed Zip DLL API functions


typedef void (__stdcall *fn_prototype_RTInfo)(void);

extern  int	zCloseZipFile(void);
extern  int	zOpenZipFile(char *zipfilename);
extern	char*	zGetLastErrorAsText(void);
extern  int	zGetTotalFiles(void);
extern	int	zGetTotalBytes(void);
extern	int	zGetSelectedFiles(void);
extern	int	zGetSelectedBytes(void);
extern	int	zGetSkippedFiles(void);
extern	BOOL	zGetRunTimeInfo(int &ProcessedFiles,int &ProcessedBytes);
extern	BOOL	zCancelOperation(void);
extern	int	zExtractOne(int ItemNo,char *ExtractDirectory,char *Password, BOOL OverwriteExisting, BOOL SkipOlder, BOOL UseFolders, BOOL TestOnly,fn_prototype_RTInfo RTInfoFunc);
extern	int	zExtractSelected(char *ExtractDirectory,char *Password,  BOOL OverwriteExisting, BOOL SkipOlder, BOOL UseFolders,BOOL TestOnly,fn_prototype_RTInfo RTInfoFunc);
extern	int	zExtractAll(char *ExtractDirectory,char *Password,  BOOL OverwriteExisting, BOOL SkipOlder, BOOL UseFolders,BOOL TestOnly,fn_prototype_RTInfo RTInfoFunc);
extern	char* zGetFileName(int index);
extern	char* zGetFileExt(int index);
extern	char* zGetFilePath(int index);
extern	int	zGetFileDate(int index);
extern	int	zGetFileTime(int index);
extern	int	zGetFileSize(int index);
extern	int	zGetCompressedFileSize(int index);
extern	BOOL	zFileIsEncrypted(int index);
extern	char* zGetLastOperResult(int index);
extern	BOOL	zFileIsSelected(int index);
extern	BOOL	zSelectFile(int index,BOOL how);
extern	int	zCompressFiles(char *TempDir, char *Password, int CompressionMethod, BOOL ResetArchiveAttribute, int SpanSize, char *Comment, fn_prototype_RTInfo RTInfoFunc);
extern	int	zOrderFile(char *FileName, char *StoredName, int UpdateMode);
extern	int	zCreateNewZip(char *ZipFileName);


extern	BOOL zUnselectAll(void);
extern	int zSelectByWildcards(char *FileMask,BOOL IncludeSubfolders); 
extern	int zOrderByWildcards(char *FileMask, char *BasePath, BOOL IncludeSubfolders, BOOL CheckArchiveAttribute, int UpdateMode); 
extern	int zDeleteFiles(void); 
extern	int zGetOrderedFiles(void); 
extern	int zGetOrderedBytes(void); 
extern	char* zGetComment(void); 
extern	BOOL zIsSpanned(void); 
