unit uExtrOpt;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, Outline, DirOutln, Buttons, FileCtrl, ComCtrls, ExtCtrls;


type
  TfExtrOpt = class(TForm)
    Label1: TLabel;
    cmbDir: TComboBox;
    GroupBox1: TGroupBox;
    cbOver: TCheckBox;
    cbUse: TCheckBox;
    btnOk: TBitBtn;
    btnCancel: TBitBtn;
    edPswd: TEdit;
    Label2: TLabel;
    btnTest: TBitBtn;
    chkHide: TCheckBox;
    gbFiles: TGroupBox;
    radAllFiles: TRadioButton;
    radSelFiles: TRadioButton;
    cbSkip: TCheckBox;
    DirListBox: TDirectoryListBox;
    rbWildcards: TRadioButton;
    lblWildcards: TLabel;
    edWildcards: TEdit;
    chkSubfolders: TCheckBox;
    procedure chkHideClick(Sender: TObject);
    procedure DirListBoxChange(Sender: TObject);
    procedure radAllFilesClick(Sender: TObject);
    procedure radSelFilesClick(Sender: TObject);
    procedure rbWildcardsClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fExtrOpt: TfExtrOpt;

implementation

{$R *.DFM}



//Hide the password typing
procedure TfExtrOpt.chkHideClick(Sender: TObject);
begin
  if chkHide.Checked then
    edPswd.PasswordChar := '*'
  else
    edPswd.PasswordChar := #0;
end;


procedure TfExtrOpt.DirListBoxChange(Sender: TObject);
begin
  cmbDir.Text := DirListBox.Directory;
end;

procedure TfExtrOpt.radAllFilesClick(Sender: TObject);
begin
  lblWildcards.Enabled := False;
  edWildcards.Enabled := False;
  edWildcards.Color := clMenu;
  chkSubfolders.Enabled := False;
end;

procedure TfExtrOpt.radSelFilesClick(Sender: TObject);
begin
  lblWildcards.Enabled := False;
  edWildcards.Enabled := False;
  edWildcards.Color := clMenu;
  chkSubfolders.Enabled := False;
end;

procedure TfExtrOpt.rbWildcardsClick(Sender: TObject);
begin
  lblWildcards.Enabled := True;
  edWildcards.Enabled := True;
  edWildcards.Color := clWindow;
  chkSubfolders.Enabled := True;
end;

end.


